/*---------------------------------------------------------+
+ PROCEDURE  CRIA_FATOS                                    +
+ FUNO: CRIAO DE FATOS DE DW NA BASE DE DADOS          +
+                                                          +
+ CRIAO: 27/09/2007                                      +
+ RAPHAEL ERNANI RODRIGUES                                 +
+                                                          +
+---------------------------------------------------------*/
create or replace
PROCEDURE CRIA_FATOS (P_CDTABELADW IN VARCHAR2,
                     P_CDITEMDW IN VARCHAR2,
                     P_NMITEMDW IN VARCHAR2,
					 P_DSHINTITEM IN VARCHAR2,
                     P_NMAREANEGDW IN VARCHAR2)
IS
   V_COUNT       INTEGER;
   V_COUNT2      INTEGER;
   V_CDAREANEGDW VARCHAR2(05);
   V_NMITEMDW    VARCHAR2(100);
   V_DSHINTITEM  VARCHAR2(200);
   V_TRY         INTEGER := 0;
BEGIN
   SELECT COUNT(*)
   INTO V_COUNT
   FROM ITEMDW
   WHERE CDITEMDW   = P_CDITEMDW
     AND CDTABELADW = P_CDTABELADW;
   IF V_COUNT=0 THEN   
      BEGIN
         SELECT CDAREANEGDW
         INTO   V_CDAREANEGDW
         FROM   AREANEGDW
         WHERE  NMAREANEGDW = P_NMAREANEGDW
           AND  ROWNUM = 1;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            SELECT LPAD(NVL(MAX(CDAREANEGDW)+1,0),5,'0')
            INTO V_CDAREANEGDW
            FROM AREANEGDW;
            INSERT INTO AREANEGDW
            (CDAREANEGDW,NMAREANEGDW)
            VALUES
            (V_CDAREANEGDW,P_NMAREANEGDW);         
      END;
      V_NMITEMDW 	:= P_NMITEMDW;
	  V_DSHINTITEM	:= P_DSHINTITEM;
      LOOP 
         SELECT COUNT(*)
         INTO   V_COUNT
         FROM   ITEMDW
         WHERE  NMITEMDW = V_NMITEMDW;
         IF V_COUNT=0 THEN
            SELECT COUNT(*)
            INTO V_COUNT2
            FROM TABELADW
            WHERE CDTABELADW = P_CDTABELADW;
            IF V_COUNT2=0 THEN
               INSERT INTO TABELADW 
               (CDTABELADW, NMTABELADW) 
               VALUES
               (P_CDTABELADW, P_CDTABELADW);
            END IF;
            
            
            INSERT INTO ITEMDW
            (CDTABELADW,   CDITEMDW,   NMITEMDW,   DSHINTITEM, CDAREANEGDW,   IDFATODW, IDTPFATODW)
            VALUES
            (P_CDTABELADW, P_CDITEMDW, V_NMITEMDW, V_DSHINTITEM, V_CDAREANEGDW, 'S',      'M');
         ELSE
            IF LENGTH(V_NMITEMDW||V_TRY)<=30 THEN
               V_NMITEMDW := V_NMITEMDW||V_TRY;
            ELSE
               V_TRY := V_TRY + 1;
               V_NMITEMDW := P_NMITEMDW;
               IF LENGTH(V_NMITEMDW||V_TRY)>=30 THEN
                  V_COUNT := 0;
               END IF;
            END IF;
         END IF;   
         EXIT WHEN V_COUNT = 0; 
      END LOOP;
   END IF;
END;
/


--VERSAO--
BEGIN ATUVEROBJ('CRIA_FATOS','4.11.000'); END;
/