CREATE OR REPLACE FUNCTION DIAS_TRABALHO
                 (P_CDEMPRESA IN FUNCIONARIO.CDEMPRESA%TYPE,
                  P_CDFILIAL  IN FUNCIONARIO.CDFILIAL%TYPE,
                  P_CDFUNC    IN FUNCIONARIO.CDFUNC%TYPE,
                  P_DTINI     IN DATE,
                  P_DTFIN     IN DATE) RETURN NUMBER IS

    V_TPHORARIO   VARCHAR2(01);
    V_QTDEDIAS    NUMBER;
    V_DTINICHBFUN DATE;

BEGIN
   V_QTDEDIAS := 0;

   SELECT MAX(IDTPHORARIO)
   INTO V_TPHORARIO
   FROM PAR_FILIAL_RH
   WHERE CDFILIAL = P_CDFILIAL;

   IF V_TPHORARIO = 'H' THEN
      /* VERIFICA SE EXISTE HORRIO BASE CADASTRADO P/ O FUNC.
         SE NO EXISTIR ELE BUSCA O HORRIO BASE DA FILIAL DO FUNC.*/

      SELECT MAX(DTINICHBFUN) INTO V_DTINICHBFUN
      FROM HORBASFU
      WHERE CDEMPRESA   = P_CDEMPRESA AND
            CDFUNC      = P_CDFUNC    AND
            DTINICHBFUN = (SELECT MAX(DTINICHBFUN)
                           FROM HORBASFU
                           WHERE CDEMPRESA   = P_CDEMPRESA AND
                                 CDFUNC      = P_CDFUNC    AND
                                 DTINICHBFUN <= SYSDATE);

      IF NOT V_DTINICHBFUN IS NULL THEN

         SELECT COUNT(DTDATA) INTO V_QTDEDIAS
         FROM DATA
         WHERE (DTDATA BETWEEN P_DTINI AND P_DTFIN) AND
               (TO_CHAR(DTDATA,'D') IN (SELECT IDDIHBFUN
                                        FROM HORBASFU
                                        WHERE CDEMPRESA   = P_CDEMPRESA   AND
                                              CDFUNC      = P_CDFUNC      AND
                                              DTINICHBFUN = V_DTINICHBFUN AND
                                              ((NOT HRENT1HBFUN IS NULL) OR
                                               (NOT HRENT2HBFUN IS NULL)))) AND
               (NOT DTDATA IN (SELECT DTFERIFILI
                               FROM FERIFILI
                               WHERE (CDFILIAL = P_CDFILIAL) AND
                                     (DTFERIFILI BETWEEN P_DTINI AND P_DTFIN)));
      ELSE

         SELECT COUNT(DTDATA) INTO V_QTDEDIAS
         FROM DATA
         WHERE (DTDATA BETWEEN P_DTINI AND P_DTFIN) AND
               (TO_CHAR(DTDATA,'D') IN (SELECT IDDIHBFIL
                                        FROM HORBASFI
                                        WHERE CDFILIAL = P_CDFILIAL   AND
                                              DTHBFIL  = (SELECT MAX(DTHBFIL)
                                                          FROM HORBASFI
                                                          WHERE CDFILIAL = P_CDFILIAL AND
                                                                DTHBFIL <= SYSDATE) AND
                                              ((NOT HRENT1HBFIL IS NULL) OR
                                               (NOT HRENT2HBFIL IS NULL)))) AND
               (NOT DTDATA IN (SELECT DTFERIFILI
                               FROM FERIFILI
                               WHERE (CDFILIAL = P_CDFILIAL) AND
                                     (DTFERIFILI BETWEEN P_DTINI AND P_DTFIN)));
      END IF;

   ELSE
      SELECT COUNT(DTESCTRA) INTO V_QTDEDIAS
      FROM ESC_TRABALHO
      WHERE CDEMPRESA = P_CDEMPRESA AND
            CDFUNC    = P_CDFUNC    AND
            DTESCTRA BETWEEN P_DTINI AND P_DTFIN;
   END IF;

   RETURN(V_QTDEDIAS);
END;
/
