/******************************************************************************/
/***************************** GRAVA PEDIDO ***********************************/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'GRAVA_PEDIDO' AND
                 TYPE = 'P' 		      AND
	              U.UID = O.UID           AND
	              U.NAME = USER)
DROP PROCEDURE GRAVA_PEDIDO
GO

CREATE PROCEDURE GRAVA_PEDIDO (@P_CDFILIAL       VARCHAR(4),
                               @P_NRPEDIDO       VARCHAR(10),
                               @P_CDCLIENTE      VARCHAR(21),
                               @P_CDMODPGTO      VARCHAR(5),
                               @P_DTPEDIDO       DATETIME,
                               @P_DTENTPED       DATETIME,
                               @P_NRINSJURTRAN   VARCHAR(20),
                               @P_IDTPIJURTRAN   VARCHAR(1),
                               @P_CDOPELANPED    VARCHAR(12),
                               @P_CDFILIALPED    VARCHAR(4),
                               @P_CDTIPORECE     VARCHAR(3),
                               @P_CDVENDEDOR     VARCHAR(4),
                               @P_CDTIPOOPER     VARCHAR(2),
                               @P_CDPRECOBASE    VARCHAR(2),
                               @P_CDFILLANCA     VARCHAR(4),
                               @P_CDFILSOLI      VARCHAR(4),
                               @P_NRSOLICMP      VARCHAR(10),
                               @P_CDTIPOEDITAL   VARCHAR(3),
                               @P_NREMPENHO      VARCHAR(20),
                               @P_CDFILIORCEVE   VARCHAR(4)  = NULL,
                               @P_NRORCAEVENTO   VARCHAR(10) = NULL,
                               @P_NRSEQORCAEVE   VARCHAR(2)  = NULL,
                               @P_CDDEPORCAEVE   VARCHAR(3)  = NULL,
                               @P_NRSEQORCAMENTO NUMERIC     = NULL,
                               @P_CDMENSERRO     VARCHAR(20) OUTPUT)

AS
BEGIN
   DECLARE @V_CTREGISTRO      NUMERIC;
   DECLARE @V_CTPARAM         NUMERIC;
   DECLARE @V_DTENTPED        DATETIME;
   DECLARE @V_DTPEDIDO        DATETIME;
   DECLARE @V_NRDIASENTPED    VARCHAR(4);

   DECLARE @V_IDSITPEDIDO     VARCHAR(1);
   DECLARE @V_CDCLIENTE       VARCHAR(21);
   DECLARE @V_CDMODPGTO       VARCHAR(5);
   DECLARE @V_CDVENDEDOR      VARCHAR(4);
   DECLARE @V_CDPRECOBASE     VARCHAR(2);

   DECLARE @V_IDTPFORPGTOMOD  VARCHAR(1);
   DECLARE @V_NRDIAPGFIXMOD   SMALLINT;
   DECLARE @V_NRPARCPGTOMOD   SMALLINT;
   DECLARE @V_CDFORMPGTO      VARCHAR(2);
   DECLARE @V_ERRO            VARCHAR(20);
   DECLARE @V_CDTIPOOPER      VARCHAR(2);
   DECLARE @V_IDOBRTPOPPED    VARCHAR(1);
   DECLARE @V_CDOPERPED       VARCHAR(12);
   DECLARE @V_CDROTATRANSPED  VARCHAR(6);
   DECLARE @V_IDORIGDESTOP    VARCHAR(1);
   
   DECLARE @V_NRINSJURTRAN    VARCHAR2(20);
   DECLARE @V_CDTIPTRANS      VARCHAR2(4);
   DECLARE @V_IDPGFRETTRA     VARCHAR2(1);   

   /*VARIVEIS DO CURSOR C_PRAZO*/
   DECLARE @V_PRAZO_NRDIASMODPGTO SMALLINT;
   DECLARE @V_PRAZO_VRPERCMODPGTO double precision;

   DECLARE @C_NRDIASMODPGTO SMALLINT;
   DECLARE @C_VRPERCMODPGTO double precision;
   DECLARE @V_CDCLIENTEDEST VARCHAR(21);
   DECLARE @V_CDMODPGTODEST VARCHAR(5);
   DECLARE @V_CDVENDEDORDEST VARCHAR(4);
   DECLARE @V_CDCLIENTEORIG VARCHAR(21);
   DECLARE @V_CDMODPGTOORIG VARCHAR(5);
   DECLARE @V_CDVENDEDORORIG VARCHAR(4);
   DECLARE @V_NRSEQDIAPROD VARCHAR(4);

   DECLARE @V_DTVALIPED    DATETIME;
   DECLARE @V_IDUTVALIPED  VARCHAR(1);
   DECLARE @V_QTDIAVALIPED double precision;

   SET @P_CDMENSERRO = 'OK';
   SET @V_CDOPERPED = NULL;
   SET @V_ERRO = '';
   SET @V_CDROTATRANSPED = NULL;
   IF @P_CDFILIAL IS NULL BEGIN
      SET @V_ERRO = 'CDFILIAL;';
   END
   ELSE
      SELECT @V_CTREGISTRO = COUNT(CDFILIAL)
      FROM FILIAL
      WHERE CDFILIAL = @P_CDFILIAL;

      IF @V_CTREGISTRO = 0 BEGIN
         SET @V_ERRO = @V_ERRO + 'CDFILIAL01;';
      END;
   END;

   IF NOT(@P_CDFILIALPED IS NULL)BEGIN
      SELECT @V_CTPARAM = COUNT(*)
      FROM PARAMPEDIDO
      WHERE CDFILIAL = @P_CDFILIALPED;

      IF(@V_CTPARAM > 0)BEGIN
         SELECT @V_CDCLIENTEDEST = CDCLIENTE, @V_CDMODPGTODEST = CDMODPGTO,
                @V_CDVENDEDORDEST = CDVENDEDOR, @V_NRDIASENTPED = NRDIASENTPED,
                @V_IDSITPEDIDO = CASE IDLANCPED WHEN '3' THEN '2' ELSE IDLANCPED END,
                @V_CDTIPOOPER  = CDTIPOOPER, @V_IDOBRTPOPPED = IDOBRTPOPPED, @V_IDUTVALIPED = IDUTVALIPED,
                @V_QTDIAVALIPED = QTDIAVALIPED
         FROM PARAMPEDIDO
         WHERE
            CDFILIAL = @P_CDFILIALPED;
      END;
   END;

   SELECT @V_CTPARAM = COUNT(*)
   FROM PARAMPEDIDO
   WHERE CDFILIAL = @P_CDFILIAL;

   IF @V_CTPARAM > 0 BEGIN
      SELECT @V_CDCLIENTEORIG = CDCLIENTE,  @V_CDMODPGTOORIG = CDMODPGTO,
             @V_CDVENDEDORORIG = CDVENDEDOR, @V_NRDIASENTPED = NRDIASENTPED,
             @V_IDSITPEDIDO = CASE IDLANCPED WHEN '3' THEN '2' ELSE IDLANCPED END,
             @V_CDTIPOOPER  = CDTIPOOPER, @V_IDOBRTPOPPED = IDOBRTPOPPED, @V_IDUTVALIPED = IDUTVALIPED,
             @V_QTDIAVALIPED = QTDIAVALIPED
      FROM PARAMPEDIDO
      WHERE CDFILIAL = @P_CDFILIAL;
   END;

   IF(@V_IDOBRTPOPPED = 'S')BEGIN
      IF((@V_CDTIPOOPER  IS NULL)AND(@P_CDTIPOOPER IS NULL)) BEGIN
         SET @V_ERRO = @V_ERRO + 'CDTIPOOPER;';
      END
      ELSE BEGIN
         IF NOT(@P_CDTIPOOPER IS NULL)BEGIN
            SET @V_CDOPERPED =  @P_CDTIPOOPER;
         END
         ELSE BEGIN
            SET @V_CDOPERPED = @V_CDTIPOOPER;
         END;
      END;
   END;

   IF @P_DTPEDIDO IS NULL BEGIN
      SET @V_DTPEDIDO = CONVERT(DATETIME, CONVERT(CHAR,GETDATE(), 103));
   END
   ELSE BEGIN
      SET @V_DTPEDIDO = CONVERT(DATETIME,CONVERT (CHAR, @P_DTPEDIDO, 103));
   END;

   IF @P_DTENTPED IS NULL BEGIN
      SET @V_DTENTPED = CONVERT(DATETIME, CONVERT(CHAR, GETDATE() + CONVERT(NUMERIC, ISNULL(@V_NRDIASENTPED, 0)), 103));
   END
   ELSE BEGIN
      SET @V_DTENTPED = CONVERT(DATETIME,CONVERT (CHAR, @P_DTENTPED, 103));
   END;

   IF (@V_IDUTVALIPED  = 'S') BEGIN
      IF(@V_QTDIAVALIPED > 0) BEGIN
         SET @V_DTVALIPED = CONVERT(DATETIME, CONVERT(CHAR, GETDATE() + CONVERT(NUMERIC, ISNULL(@V_QTDIAVALIPED, 0)), 103));
      END
      ELSE BEGIN
         SET @V_DTVALIPED = GETDATE();
      END ;
   END
   ELSE BEGIN
      SET @V_DTVALIPED = NULL;
   END;

   IF (@P_NRPEDIDO IS NULL) OR
      (@P_NRPEDIDO = '') BEGIN
      SET @V_ERRO = @V_ERRO + 'NRPEDIDO;';
   END
   ELSE BEGIN
      SELECT @V_CTREGISTRO = COUNT(*)
      FROM PEDIDO
      WHERE CDFILIAL = @P_CDFILIAL
        AND NRPEDIDO = @P_NRPEDIDO;

      IF @V_CTREGISTRO > 0 BEGIN
         SET @V_ERRO = @V_ERRO + 'NRPEDIDO01;';
      END;
   END;

   IF NOT @P_CDCLIENTE IS NULL BEGIN
      SET @V_CDCLIENTE = @P_CDCLIENTE;
   END
   ELSE BEGIN
      IF NOT(@V_CDCLIENTEDEST IS NULL)BEGIN
         SET @V_CDCLIENTE = @V_CDCLIENTEDEST;
      END
      ELSE BEGIN
         SET @V_CDCLIENTE = @V_CDCLIENTEORIG;
      END;
   END;

  SELECT @V_NRINSJURTRAN = NRINSJURTRAN, 
         @V_CDTIPTRANS = CDTIPTRANS, 
         @V_IDPGFRETTRA = IDPGFRETTRANCLI
    FROM CLIENTE
   WHERE CDCLIENTE = @V_CDCLIENTE;
   
   SELECT @V_CTREGISTRO = COUNT(*)
   FROM CLIENTE
   WHERE CDCLIENTE = @V_CDCLIENTE;

   IF @V_CTREGISTRO > 0 BEGIN
      SELECT @V_CDMODPGTO = ISNULL(CDMODPGTO, @V_CDMODPGTO)
      FROM CLIENTE
      WHERE CDCLIENTE = @V_CDCLIENTE;
   END
   ELSE BEGIN
      SET @V_ERRO = @V_ERRO  + 'CDCLIENTE;';
   END;

   IF NOT @P_CDVENDEDOR IS NULL BEGIN
      SET @V_CDVENDEDOR = @P_CDVENDEDOR;
   END
   ELSE BEGIN
      IF NOT @V_CDVENDEDORDEST IS NULL BEGIN
         SET @V_CDVENDEDOR =  @V_CDVENDEDORDEST;
      END
      ELSE BEGIN
         SET @V_CDVENDEDOR = @V_CDVENDEDORORIG;
      END;
   END;

   IF @V_CDVENDEDOR IS NULL BEGIN
      SET @V_ERRO = @V_ERRO +  'CDVENDEDOR;';
   END;

   IF NOT @P_CDMODPGTO IS NULL BEGIN
      SET @V_CDMODPGTO = @P_CDMODPGTO;
   END
   ELSE BEGIN
      IF NOT @V_CDMODPGTODEST IS NULL BEGIN
         SET @V_CDMODPGTO = @V_CDMODPGTODEST;
      END
      ELSE BEGIN
         SET @V_CDMODPGTO =  @V_CDMODPGTOORIG;
      END;
   END;  

   IF @V_CDMODPGTO IS NOT NULL BEGIN
      SELECT @V_CTREGISTRO = COUNT(CDMODPGTO)
      FROM MODPGTO
      WHERE CDMODPGTO = @V_CDMODPGTO;

      IF @V_CTREGISTRO > 0 BEGIN
         SELECT @V_IDTPFORPGTOMOD = MAX(IDTPFORPGTOMOD),
                @V_NRDIAPGFIXMOD  = MAX(NRDIAPGFIXMOD),
                @V_NRPARCPGTOMOD  = MAX(NRPARCPGTOMOD),
                @V_CDFORMPGTO     = MAX(CDFORMPGTO),
                @V_IDSITPEDIDO    = ISNULL(MAX(CASE IDLANCPEDMOD WHEN '3' THEN '2' ELSE IDLANCPEDMOD END), @V_IDSITPEDIDO)
         FROM MODPGTO
         WHERE CDMODPGTO = @V_CDMODPGTO;
      END
      ELSE BEGIN
         SET @V_ERRO = @V_ERRO + 'CDMODPGTO01;';
      END;
   END
   ELSE BEGIN
      SET @V_ERRO = @V_ERRO + 'CDMODPGTO;';
   END;

   IF @V_IDSITPEDIDO IS NULL BEGIN
      SET @V_ERRO = @V_ERRO + 'IDSITPEDIDO;';
   END;

   IF NOT @P_CDPRECOBASE IS NULL BEGIN
      SET @V_CDPRECOBASE = @P_CDPRECOBASE;
   END
   ELSE BEGIN
      SELECT @V_CTREGISTRO = COUNT(CDPRECOBASE)
      FROM PRECOBASECLI
      WHERE CDCLIENTE = @V_CDCLIENTE
        AND IDPRBASEPRIN = 'S';

      IF @V_CTREGISTRO > 0 BEGIN
         SELECT @V_CDPRECOBASE = MAX(CDPRECOBASE)
         FROM PRECOBASECLI
         WHERE CDCLIENTE = @V_CDCLIENTE
           AND IDPRBASEPRIN = 'S';
      END
      ELSE BEGIN
         SELECT @V_CTREGISTRO = COUNT(CDPRECOBASE)
         FROM VENDEDOR
         WHERE CDVENDEDOR = @V_CDVENDEDOR;

         IF @V_CTREGISTRO > 0 BEGIN
            SELECT @V_CDPRECOBASE = MAX(CDPRECOBASE)
            FROM VENDEDOR
            WHERE CDVENDEDOR = @V_CDVENDEDOR;
         END
         ELSE BEGIN
            SELECT @V_CTREGISTRO = COUNT(CDPRECOBASE)
            FROM PRECOUTI
            WHERE CDFILIAL  = @P_CDFILIAL
              AND CDMODPGTO = @V_CDMODPGTO;

            IF @V_CTREGISTRO > 0 BEGIN
               SELECT @V_CDPRECOBASE = MAX(CDPRECOBASE)
               FROM PRECOUTI
               WHERE CDFILIAL  = @P_CDFILIAL
                 AND CDMODPGTO = @V_CDMODPGTO;
            END
            ELSE BEGIN
               SET @V_ERRO = @V_ERRO + 'CDPRECOBASE;';
            END;
         END;
      END;
   END;

   IF @V_ERRO <> '' BEGIN
      SET @P_CDMENSERRO = @V_ERRO;
   END;

   SET @V_NRSEQDIAPROD = NULL;
   IF NOT @P_NRORCAEVENTO IS NULL BEGIN
      SELECT @V_NRSEQDIAPROD = MAX(NRSEQDIAPROD)
      FROM PEDIDO
      WHERE CDFILIAL     = @P_CDFILIAL
        AND DTENTPED     = CONVERT(DATETIME, CONVERT(VARCHAR, @P_DTENTPED, 103));

      IF NOT @V_NRSEQDIAPROD IS NULL AND @P_NRSEQORCAEVE = '00' BEGIN
         SET @V_NRSEQDIAPROD = REPLICATE('0', 3 - LEN(CONVERT(CHAR(3), CONVERT(INT, @V_NRSEQDIAPROD) + 1))) + CONVERT(CHAR(3), CONVERT(INT, @V_NRSEQDIAPROD) + 1);
      END
      ELSE BEGIN
         IF @P_NRSEQORCAEVE = '00' BEGIN
            SET @V_NRSEQDIAPROD = '001';
         END
         ELSE BEGIN
            SELECT @V_NRSEQDIAPROD = MAX(NRSEQDIAPROD)
            FROM PEDIDO
            WHERE CDFILIAL     = @P_CDFILIAL
              AND NRORCAEVENTO = @P_NRORCAEVENTO
              AND DTENTPED     = CONVERT(DATETIME, CONVERT(VARCHAR, @P_DTENTPED, 103));
            SET @V_NRSEQDIAPROD = @V_NRSEQDIAPROD;
         END;
      END;
   END;

   IF NOT (@V_CDTIPOOPER IS NULL) AND (@V_CDTIPOOPER <> '') BEGIN
      SELECT @V_IDORIGDESTOP = IDORIGDESTOP
        FROM TIPOOPERAC
       WHERE CDTIPOOPER = @V_CDTIPOOPER AND
             IDENTRSAIDOP = 'S';

      IF @V_IDORIGDESTOP = 'C' BEGIN
         SELECT @V_CDROTATRANSPED = CDROTATRANS
           FROM CLIENROTA
          WHERE CDCLIENTE = @V_CDCLIENTE AND
                IDROTAPRINCLI = 'S';
      END;

      IF @V_IDORIGDESTOP = 'L' BEGIN
         SELECT @V_CDROTATRANSPED = CDROTATRANS
           FROM FILIALROTA
          WHERE CDFILIAL = @P_CDFILIAL AND
                IDROTAPRINCFILI = 'S';
      END;
   END;

   IF @P_CDMENSERRO = 'OK' BEGIN
      INSERT INTO PEDIDO
         (CDFILIAL,     NRPEDIDO,     IDSITPEDIDO,   CDCLIENTE,    IDPRIOPED,     DTPEDIDO,
          DTENTPED,     CDMODPGTO,    IDTPFORPGTPED, CDFORMPGTO,   NRDIAPGFIXPED, NRPARCPGTOPED,
          IDTPIJURTRAN, NRINSJURTRAN, CDTIPTRANS,    IDPGFRETTRAN, DTHRLANPED,    CDOPELANPED,  CDFILIALPED,   CDTIPORECE,
          CDVENDEDOR,   IDENTRSAIDOP, CDTIPOOPER,    CDPRECOBASE,  DTVALIPED,     CDFILLANCA,
          CDFILSOLI,    NRSOLICMP,    CDTIPOEDITAL,  CDFILIALORC,  NRORCAEVENTO,  NRSEQORCAEVE,
          CDDEPTO, NREMPENHO, NRSEQDIAPROD, CDROTATRANSPED, NRSEQORCAMENTO, IDUTDIAPAGPED)
      VALUES
         (@P_CDFILIAL,     @P_NRPEDIDO,     @V_IDSITPEDIDO,    @V_CDCLIENTE,    '1',              @V_DTPEDIDO,
          @V_DTENTPED,     @V_CDMODPGTO,    @V_IDTPFORPGTOMOD, @V_CDFORMPGTO,   @V_NRDIAPGFIXMOD, @V_NRPARCPGTOMOD,
          @P_IDTPIJURTRAN, @V_NRINSJURTRAN, @V_CDTIPTRANS,     @V_IDPGFRETTRA,  GETDATE(),         @P_CDOPELANPED,  @P_CDFILSOLI,   @P_CDTIPORECE,
          @V_CDVENDEDOR,   'S',             @V_CDOPERPED,      @V_CDPRECOBASE,  @V_DTVALIPED,     @P_CDFILLANCA,
          @P_CDFILSOLI,    @P_NRSOLICMP,    @P_CDTIPOEDITAL,   @P_CDFILIORCEVE, @P_NRORCAEVENTO,  @P_NRSEQORCAEVE,
          @P_CDDEPORCAEVE, @P_NREMPENHO,    @V_NRSEQDIAPROD,   @V_CDROTATRANSPED, @P_NRSEQORCAMENTO, 'I');

      DECLARE C_PRAZO CURSOR FOR
      SELECT NRDIASMODPGTO, VRPERCMODPGTO
      FROM PRAZOMODPGTO
      WHERE
         CDMODPGTO = @V_CDMODPGTO
      OPEN C_PRAZO;
      FETCH NEXT FROM C_PRAZO INTO @V_PRAZO_NRDIASMODPGTO, @V_PRAZO_VRPERCMODPGTO;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         INSERT INTO PRAZOPGTOPED( CDFILIAL   , NRPEDIDO   , NRDIASPGTOPED        , VRPERCPGTOPED)
                           VALUES( @P_CDFILIAL, @P_NRPEDIDO, @V_PRAZO_NRDIASMODPGTO, @V_PRAZO_VRPERCMODPGTO);

      FETCH NEXT FROM C_PRAZO INTO  @V_PRAZO_NRDIASMODPGTO, @V_PRAZO_VRPERCMODPGTO;
   END;
   CLOSE C_PRAZO;
   DEALLOCATE C_PRAZO;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GRAVA_PEDIDO','6.29.xxx';
GO