/* @C:\WEB_511\Sql\End_Conv\Oracle\5055_FISSTPO_Consulta_Fiscal.SQL
   Descrio:
   Procedure para consulta dos Parametros fiscais */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'CONSULTA_FISCAL' AND
	        TYPE = 'P' 		       AND
	        U.UID = O.UID                  AND
	        U.NAME = USER)
DROP PROCEDURE CONSULTA_FISCAL
GO


CREATE PROCEDURE CONSULTA_FISCAL
    @P_EMPRESA     VARCHAR(02),
    @P_ENTRSAID    VARCHAR(01),
    @P_TIPOOPER    VARCHAR(02),
    @P_INSCESTA    VARCHAR(16),
    @P_CDGRUPOFISC VARCHAR(03),
    @P_PRODUTO     VARCHAR(20),
    @P_INIVALID    DATETIME,
    @P_IDINTEREST  VARCHAR(01),
    @P_IMPOSTO     VARCHAR(02),
    @P_PAISORIG    VARCHAR(04),
    @P_ESTAORIG    VARCHAR(02),
    @P_PAISDEST    VARCHAR(04),
    @P_ESTADEST    VARCHAR(02),
    @P_CDMUNICIPIO VARCHAR(04),
    @P_BASECALC    NUMERIC(15,2),
    @P_FILIAL      VARCHAR(04),
    @P_LANCTONF    VARCHAR(10),
    @P_IDINTERNAC  VARCHAR(01)
AS
BEGIN 
   EXEC CONSULTA_CST @P_ENTRSAID, @P_EMPRESA, @P_PRODUTO, @P_INSCESTA, @P_TIPOOPER, @P_FILIAL, @P_LANCTONF, @P_CDGRUPOFISC, @P_IDINTEREST, @P_IDINTERNAC;

   EXEC CONSULTA_CFOP @P_ENTRSAID, @P_EMPRESA, @P_PRODUTO, @P_INSCESTA, @P_TIPOOPER, @P_PAISORIG,
                      @P_ESTAORIG, @P_PAISDEST, @P_ESTADEST, @P_FILIAL, @P_LANCTONF, @P_CDGRUPOFISC, @P_INIVALID;

   EXEC CONSULTA_INCIDENCIA @P_ENTRSAID, @P_EMPRESA, @P_PRODUTO, @P_INSCESTA, @P_TIPOOPER, @P_FILIAL, @P_LANCTONF, @P_CDGRUPOFISC, '', @P_IDINTEREST, '';

   EXEC CONSULTA_ALIQUOTA @P_IMPOSTO, @P_ENTRSAID, @P_EMPRESA, @P_PRODUTO, @P_INSCESTA, @P_PAISORIG, @P_ESTAORIG,
                          @P_PAISDEST, @P_ESTADEST, @P_CDMUNICIPIO, @P_BASECALC, @P_INIVALID, @P_FILIAL, @P_LANCTONF, @P_CDGRUPOFISC,@P_TIPOOPER;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CONSULTA_FISCAL','5.30.xxx';
GO
